package com.jpattern.orm.classmapper;

import java.util.List;

import com.jpattern.orm.crud.AColumnValueGenerator;
import com.jpattern.orm.query.LockMode;

/**
 * 
 * @author Francesco Cina
 *
 * 08/giu/2011
 */
public interface ITableMap<T>  {

	String getSchemaName();

	String getTableName();

	String getTableNameWithSchema();

	String getDBColumnName( String javaFieldName );

	AColumnValueGenerator getGeneratorByColumnName( String columnName , boolean ignoreGenerators);

	AColumnValueGenerator getGeneratorByJavaFieldName( String javaFieldName );

	List<String> getPrimaryKeyFieldNames();

	List<String> getAllFieldNames();

	String getJavaFieldName(String dbColumnName);

	/**
	 * 
	 * @return true if the table has a field that represents the version of the records
	 */
	boolean isVersionable();

	/**
	 * 
	 * @return the name of the db column field that represents the record's version
	 */
	String getVersionJavaFieldName();

	LockMode getVersionLoadLockMode();

	boolean hasGeneratedField();

}
